from flask import Flask, jsonify, request, Response
from datetime import datetime

app = Flask(__name__)

events = {0: {'id': 0, 'session': 0, 'info': '{"defects": 1}', 'dt': datetime(2024, 10, 10, 8, 0)},
          1: {'id': 1, 'session': 1, 'info': '{"defects": 1}', 'dt': datetime(2024, 10, 10, 8, 5)},
          2: {'id': 2, 'session': 0, 'info': '{"defects": 1}', 'dt': datetime(2024, 10, 10, 8, 10)},
          3: {'id': 3, 'session': 1, 'info': '{"defects": 1}', 'dt': datetime(2024, 10, 10, 8, 15)}}


@app.route('/', methods=['GET', 'POST'])
def get_all():
    if request.method == 'POST':
        dto = request.get_json()['dto']
        new_id = max(events.keys()) + 1
        events[new_id] = {
            'id': new_id,
            'session': dto['session'],
            'info': dto['info'],
            'dt': datetime.now()
        }
        return jsonify(events[new_id])
    return jsonify(events)


@app.route('/<int:msg_id>', methods=['GET', 'PUT', 'DELETE'])
def get_by_id(msg_id):
    if msg_id not in events.keys():
        return Response(status=404)

    if request.method == 'PUT':
        dto = request.get_json()['dto']
        events[msg_id] = {
            'session': dto['session'],
            'info': dto['info'],
            'dt': datetime.now()
        }
        return events[msg_id]
    elif request.method == 'DELETE':
        events.pop(msg_id)
        return Response(status=200)

    return jsonify(events[msg_id])


if __name__ == '__main__':
    app.run(host='0.0.0.0', use_reloader=False, port=8081)
