from flask import Flask, jsonify, request, Response
from datetime import datetime

app = Flask(__name__)

sessions = {0: {'id': 0, 'info': '{"distance": 1}', 'dt_start': datetime(2024, 10, 10, 8, 0),
                'dt_end': datetime(2024, 10, 11, 8, 0)},
            1: {'id': 1, 'info': '{"distance": 1}', 'dt_start': datetime(2024, 10, 12, 8, 0),
                'dt_end': datetime(2024, 10, 13, 8, 0)},
            2: {'id': 2, 'info': '{"distance": 1}', 'dt_start': datetime(2024, 10, 14, 8, 0),
                'dt_end': datetime(2024, 10, 15, 8, 0)},
            3: {'id': 3, 'info': '{"distance": 1}', 'dt_start': datetime(2024, 10, 16, 8, 0),
                'dt_end': datetime(2024, 10, 17, 8, 0)},
            }


@app.route('/', methods=['GET', 'POST'])
def get_all():
    if request.method == 'POST':
        dto = request.get_json()['dto']
        new_id = max(sessions.keys()) + 1
        sessions[new_id] = {
            'id': new_id,
            'info': dto['info'],
            'dt_start': datetime.now(),
            'dt_end': datetime.now() + datetime.timedelta(days=1)

        }
        return jsonify(sessions[new_id])
    return jsonify(sessions)


@app.route('/<int:msg_id>', methods=['GET', 'PUT', 'DELETE'])
def get_by_id(msg_id):
    if msg_id not in sessions.keys():
        return Response(status=404)

    if request.method == 'PUT':
        dto = request.get_json()['dto']
        sessions[msg_id] = {
            'info': dto['info'],
            'dt_start': datetime.now(),
            'dt_end': datetime.now() + datetime.timedelta(days=1)
        }
        return sessions[msg_id]
    elif request.method == 'DELETE':
        sessions.pop(msg_id)
        return Response(status=200)

    return jsonify(sessions[msg_id])


if __name__ == '__main__':
    app.run(host='0.0.0.0', use_reloader=False, port=8082)
